# Copyright 2016-2018 Ioan Vancea, Markus Scheidgen
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
#   http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

from flask import Blueprint
from flask_cors import CORS
from ..decorators import etag

api = Blueprint('api', __name__)
# enable CORS for entire Blueprint with default options
CORS(api)


# don't forget to uncomment if caching/etag needed
@api.after_request
@etag
def after_request(rv):
    """Generate an ETag header for all routes in this blueprint.
    If-Match and If-None-Match can be used by API clients
    """
    return rv

from . import routes, errors
